# 1.1.4 Machine Interpretation of a Program

## Session Overview

This lecture introduces the notion of decomposition and abstraction by specification. It also covers Python modules, functions, parameters, and scoping. Finally, it uses the Python assert statement and type 'str'.

## Session Activities

### Lecture Videos

* [Lecture 4: Machine Interpretation of a Program](http://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-00sc-introduction-to-computer-science-and-programming-spring-2011/unit-1/lecture-4-machine-interpretation-of-a-program/) (00:50:18)
  * **About this Video** - Topics covered: Decomposition, module, function, abstraction, formal parameter, actual parameter, argument, assert, scope, mapping, stack, last in first out, LIFO, strings, slicing.
  * **Resources**:
    * [Lecture Code]()
    * [Lecture code handout (PDF)](http://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-00sc-introduction-to-computer-science-and-programming-spring-2011/unit-1/lecture-4-machine-interpretation-of-a-program/MIT6_00SCS11_lec04.pdf)

* Recitation Videos
  * **Recitation 2**: Loops, Tuples, Strings and Functions (00:57:42)
  * **About this video**: Topics covered: loops, tuples, concatenating tuples and strings, string operations, immutability, range function, slicing, types of data structures, decrementing function, global and local variables, global keepers.

### Recitation Videos

* [Recitation 2: Loops, Tuples, Strings and Functions](http://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-00sc-introduction-to-computer-science-and-programming-spring-2011/unit-1/lecture-4-machine-interpretation-of-a-program/#?w=535) (00:57:42)

## Check Yourself

### What is decomposition?

Decomposition breaks a problem into self-contained, manageable parts.

### What is abstraction?

Abstraction allows us to ignore the details of a piece of code, and use it as a black box - input x, get y.

### What is the difference between formal and actual parameters?

Formal parameters are the names of variables used inside a procedure; actual parameters (or arguments) are the values to those names.
